package com.fuzamei.utils;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import javax.validation.ConstraintViolation;
import javax.validation.Validation;
import javax.validation.Validator;
import javax.validation.ValidatorFactory;

/**
 * 
 * @author ylx
 * @describe 针对hibernate-validator的实体类进行数据校验的工具类
 */
public class ValidationUtil {
	
	/**
	 * 
	* @Title: validate
	* @Description: TODO(校验一个实体类的所有校验失败信息)
	* @param @param bo
	* @param @return    设定文件
	* @return List<String>    返回的是数据校验的所有校验失败信息，封装在一个list中作为返回值
	* @author ylx
	* @date 2017年12月26日 下午3:48:40
	* @throws
	* 
	 */
	public static <T> List<String> validate(T bo){
		ValidatorFactory factory = Validation.buildDefaultValidatorFactory();
		Validator validator = factory.getValidator();
		Set<ConstraintViolation<T>> validateSet = validator.validate(bo);
		List<String> list=new ArrayList<String>();
		for (ConstraintViolation<T> validate : validateSet) {
			list.add(validate.getMessage());
		}
		return list;	//包含所有校验出错的信息
		
		/*使用hibernate validator出现上面的错误， 需要 注意

		@NotNull 和 @NotEmpty  和@NotBlank 区别

		@NotEmpty 用在集合类上面
		@NotBlank 用在String上面
		@NotNull    用在基本类型上*/
	}
	
	
}
